import java.io.*;
import java.util.*;

// Judge Solution by Jesus Ramos

// Simple DFS problem
// Solution : Find an oil spot, mark it as visited,
// recursively check adjacent locations and repeat this procedure
// Every time you find that first new oil spot increment the number
// of deposits you've found and use DFS to exhaust all reachable
// spots that consist of the deposit
public class OilDeposits
{
    static Plot[][] plotMap;
    static int numOilDeposits;
    static int m, n;
	
    public static void main(String[] args) throws Exception
    {
        Scanner in = new Scanner(System.in);
        while (in.hasNextLine())
        {
            numOilDeposits = 0;
            m = in.nextInt();
            n = in.nextInt();
            in.nextLine();
            if (m == 0 && n == 0)
                break;
            plotMap = new Plot[m][n];
            for (int i = 0; i < m; i++)
            {
                String line = in.nextLine();
                for (int j = 0; j < n; j++)
                    plotMap[i][j] = new Plot(line.charAt(j));
            }
            findOilPockets();
            System.out.println(numOilDeposits);
        }
    }
    static void findOilPockets()
    {
        for (int i = 0; i < m; i++)
            for (int j = 0; j < n; j++)
                if (!plotMap[i][j].visited && plotMap[i][j].pocket == '@')
                {
                    numOilDeposits++;
                    doDfs(i, j);
                }
    }
    static void doDfs(int r, int c)
    {
        plotMap[r][c].visited = true;
        for (int i = -1; i < 2; i++)
            for (int j = -1; j < 2; j++)
            {
                int x = r + i, y = c + j;
                if (!(x == r && y == c) && inBounds(x, y) && !plotMap[x][y].visited && plotMap[x][y].pocket == '@')
                    doDfs(x, y);
            }
    }
    static boolean inBounds(int r, int c)
    {
        return (r >= 0 && r < m && c >= 0 && c < n);
    }
}
class Plot
{
    public char pocket;
    public boolean visited;

    public Plot(char c)
    {
        pocket = c;
        visited = false;
    }
}
