import java.util.*;

// Problem definition was simplified and will only contain rectangles

// Judge Solution by Jesus Ramos

// Note : This is a generalized solution that works for Triangles, Rectangles, and Circles

// GOTCHA : The only gotcha with this problem is that if the point lies on one of the sides
// then it is not considered inside, the problem states this but it is easy to over look
public class PointsInFigures
{
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        ArrayList<Shape> list = new ArrayList<Shape>();
        while (true)
        {
            String t = in.next();
            if (t.equals("r"))
                list.add(new Rectangle(in.nextDouble(), in.nextDouble(), in.nextDouble(), in.nextDouble()));
            else if (t.equals("c"))
                list.add(new Circle(in.nextDouble(), in.nextDouble(), in.nextDouble()));
            else if (t.equals("t"))
                list.add(new Triangle(in.nextDouble(), in.nextDouble(), in.nextDouble(), in.nextDouble(), in.nextDouble(), in.nextDouble()));
            else if (t.equals("*"))
                break;
        }
        int pointCount = 1;
        while (in.hasNextDouble())
        {
            double x = in.nextDouble(), y = in.nextDouble();
            if (x == 9999.9 && x == y)
                break;
            boolean inside = false;
            for (int i = 0; i < list.size(); i++)
            {
                Shape s = list.get(i);
                if ((s.type == 'r' && insideRectangle(x, y, (Rectangle)s)) || (s.type == 'c' && insideCircle(x, y, (Circle)s)) || (s.type == 't' && insideTriangle(x, y, (Triangle)s)))
                {
                    System.out.printf("Point %d is contained in figure %d\n", pointCount, i + 1);
                    inside = true;
                }
            }
            if (!inside)
                System.out.printf("Point %d is not contained in any figure\n", pointCount);
            pointCount++;
        }
    }
    // IMPORTANT : being collinear with the side of the rectangle means it is not inside
    static boolean insideRectangle(double x, double y, Rectangle r)
    {
        return x > r.x1 && x < r.x2 && y < r.y1 && y > r.y2;
    }
    static boolean insideCircle(double x, double y, Circle c)
    {
        return distance(x, y, c.x, c.y) < c.rad;
    }
    static double distance(double x1, double y1, double x2, double y2)
    {
        return Math.sqrt(Math.pow(x2 - x1, 2) + Math.pow(y2 - y1, 2));
    } 
    static double triArea(Triangle t) //Heron's area formula
    {
        double a,b,c,d;
        a = t.x1-t.x3;
        b = t.y1-t.y3;
        c = t.x2-t.x3;
        d = t.y2-t.y3;
        return (0.5 * Math.abs((a*d)-(b*c)));
    }
    static boolean insideTriangle(double x, double y, Triangle t)//tells you if x and y is in a triangle bounded by remaining points, NOT INCLUDING BORDERS
    {
        double tot, t1, t2, t3;
        tot = triArea(new Triangle(t.x1, t.y1, t.x2, t.y2, t.x3, t.y3));
        t1 = triArea(new Triangle(x, y, t.x2, t.y2, t.x3, t.y3));
        t2 = triArea(new Triangle(x, y, t.x1, t.y1, t.x2, t.y2));
        t3 = triArea(new Triangle(x, y, t.x1, t.y1, t.x3, t.y3));
        return Math.abs(t1+t2+t3 - tot) <= 0.000001 && (t1 != 0 && t2 !=0 && t3 != 0); //checks if the area of triangles linked to the main triangle
        //equals the total area of the main triangle to confirm if the point is inside
    }
}
class Triangle extends Shape
{
    public double x1, y1, x2, y2, x3, y3;
    public Triangle(double a, double b, double c, double d, double e, double f)
    {
        super('t');
        x1 = a;
        y1 = b;
        x2 = c;
        y2 = d;
        x3 = e;
        y3 = f;
    }
}
class Circle extends Shape
{
    public double x, y, rad;
    public Circle(double a, double b, double c)
    {
        super('c');
        x = a;
        y = b;
        rad = c;
    }
}
class Rectangle extends Shape
{
    public double x1, y1, x2, y2;
    public Rectangle(double a, double b, double c, double d)
    {
        super('r');
        x1 = a;
        y1 = b;
        x2 = c;
        y2 = d;
    }
}
class Shape
{
    public char type;
    public Shape(char c)
    {
        type = c;
    }
}
